#!/bin/sh

echo 2 > /proc/sys/vm/overcommit_memory
echo 100 > /proc/sys/vm/overcommit_ratio

echo "Start firmware upgrading"
echo "Start firmware upgrading" > /dev/console


#some validation
if [ -f "./fmw_board_type" ]; then
    cur_board=`factory board`
    case "$cur_board"  in
        WEP-3ax)             board_type="WEP-3ax";;
        WEP-3ax-Z)           board_type="WEP-3ax";;
        WOP-3ax)             board_type="WEP-3ax";;
    esac

    if [ -z "$board_type" ]; then
        echo "UPGRADE FAIL: wrong factory settings"
        exit 1;
    fi

    fmw_type=`cat ./fmw_board_type`
    if [ "$fmw_type" != "$board_type" ]; then
        echo "UPGRADE FAIL: firmware for $fmw_type but board is $cur_board"
        exit 1;
    fi
fi

md5_cur=`busybox md5sum ./*.w | cut -d' ' -f 1`
md5_img=`cat *.md5`
if [ "$md5_cur" != "$md5_img" ]; then
    echo "UPGRADE FAIL: Incorrect CRC";
    exit 1;
fi

#killall igmpproxy udpxy Зачем?

echo "Upgrade firmware started"
echo "Upgrade firmware started" > /dev/console
echo -ne "versionInvalid Image" > /proc/nvram/firmwares
/bin/upgrade-bin *.w > /dev/console
RETVAL=$?

if [ $RETVAL == 0 ]; then
    echo -ne "version"$(cat version) > /proc/nvram/firmwares
    echo "UPGRADE SUCCESSFULL" > /dev/console
    echo "UPGRADE SUCCESSFULL"
    if [[ -f "/proc/nvram/reboot_reason" ]]; then
        echo "upgrade" > /proc/nvram/firmwares
    else
        echo "switch" > /proc/nvram/firmwares
    fi
    if [ "$1" != "1" ]; then
        /bin/reboot
    fi
else
    echo "UPGRADE FAIL: upgrade-bit returned $RETVAL";
    exit 1;
fi
exit 0;
